/**
 * hander the datafile for hw3
 */
import java.io.*;
import java.util.*;
import java.awt.*;

public class PolygonReader
{
    private int tests;  // Number of tests
    private int test;   // cases been processed
    private LineNumberReader reader;
    private int numVertices;    // total number of vertices for current polygon
    private String line;        // General purpose line buffer
    private String token;       // Token while parsing the string
    
    public static final boolean SOURCEPOLYGON = false;
    public static final boolean CLIPPINGPOLYGON = true;
    
    /**
     * construtor using a file name
     * initialize a LineNumberReader and read total number of cases
     */
    public PolygonReader(String filename){
        try{
            // preset input file
            reader = new LineNumberReader (new FileReader(filename));
            test = 0;       // none have been processed
            line = reader.readLine ();      
            tests = Integer.parseInt(line);     // total number of cases
        }
        catch(IOException e){
        }
    }
       
    /** 
     * read the next polygon from the file iostream
     * have to be call for source polygon and clipping polygon alternatively
     */
    public  Point[] FetchNextPolygon(boolean isclipping){
        if(test>=tests) return null;
        
        Point [] vertices = null;
        try{
        int x, y;   // temporary coordinates for vertex
        line = reader.readLine ();
        StringTokenizer st = new StringTokenizer (line, "\t\n\r, ");
        token = st.nextToken();
        numVertices = Integer.parseInt (token);
        vertices = new Point [numVertices];
        
        for(int i=0;i<numVertices;i++){
            token = st.nextToken ();
            x = Integer.parseInt (token);
            token = st.nextToken ();
            y = Integer.parseInt (token);
            vertices[i]= new Point (x, y);
        }
        
        if(isclipping){
            test++;
            if(test == tests) reader = null;    // garbage collection
        }
        } catch (IOException e){
        }
        
        return vertices;
    }
}
